'use strict';












var _os = require('os');var _os2 = _interopRequireDefault(_os);
var _path = require('path');var _path2 = _interopRequireDefault(_path);
var _chalk = require('chalk');var _chalk2 = _interopRequireDefault(_chalk);
var _yargs = require('yargs');var _yargs2 = _interopRequireDefault(_yargs);
var _jestUtil = require('jest-util');
var _jestConfig = require('jest-config');
var _ = require('../');var _2 = _interopRequireDefault(_);
var _args = require('./args');var _args2 = _interopRequireDefault(_args);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };} /**
                                                                                                                                                                       * Copyright (c) 2014, Facebook, Inc. All rights reserved.
                                                                                                                                                                       *
                                                                                                                                                                       * This source code is licensed under the BSD-style license found in the
                                                                                                                                                                       * LICENSE file in the root directory of this source tree. An additional grant
                                                                                                                                                                       * of patent rights can be found in the PATENTS file in the same directory.
                                                                                                                                                                       *
                                                                                                                                                                       * 
                                                                                                                                                                       */const VERSION = require('../../package.json').version;function run(cliArgv, cliInfo) {let argv;if (cliArgv) {argv = cliArgv;} else {
    argv = _yargs2.default.usage(_args2.default.usage).options(_args2.default.options).argv;

    (0, _jestUtil.validateCLIOptions)(argv, _args2.default.options);
  }

  if (argv.help) {
    _yargs2.default.showHelp();
    process.on('exit', () => process.exit(1));
    return;
  }

  if (argv.version) {
    console.log(`v${VERSION}\n`);
    return;
  }

  if (!argv._.length) {
    console.log('Please provide a path to a script. (See --help for details)');
    process.on('exit', () => process.exit(1));
    return;
  }

  const root = process.cwd();
  const filePath = _path2.default.resolve(root, argv._[0]);

  if (argv.debug) {
    const info = cliInfo ? ', ' + cliInfo.join(', ') : '';
    console.log(`Using Jest Runtime v${VERSION}${info}`);
  }
  const options = (0, _jestConfig.readConfig)(argv, root);
  const globalConfig = options.globalConfig;
  // Always disable automocking in scripts.
  const config = Object.assign({}, options.config, {
    automock: false,
    unmockedModulePathPatterns: null });

  _2.default.createContext(config, {
    maxWorkers: _os2.default.cpus().length - 1,
    watchman: globalConfig.watchman }).

  then(hasteMap => {
    /* $FlowFixMe */
    const Environment = require(config.testEnvironment);
    const environment = new Environment(config);
    (0, _jestUtil.setGlobal)(
    environment.global,
    'console',
    new _jestUtil.Console(process.stdout, process.stderr));

    environment.global.jestProjectConfig = config;
    environment.global.jestGlobalConfig = globalConfig;

    const runtime = new _2.default(config, environment, hasteMap.resolver);
    runtime.requireModule(filePath);
  }).
  catch(e => {
    console.error(_chalk2.default.red(e.stack || e));
    process.on('exit', () => process.exit(1));
  });
}

exports.run = run;